<?php
	include "utils.php";
	include "config.php";
	set_time_limit(0);
    
    //global vars
    $date_range = array();
    $traffic_out = array();
    $traffic_in  = array();
    
    // Traffic charts Config -------------------------------------
    $bucketSize=6;
    $displayTrafficBuckets = false;
    $displaySpeedBuckets = true;
    
    //gradient
    $displayGradientBars = true;
    
    //Zoom
    $displayZoomSize = 1024;
    // END Config -------------------------------------------------

	function genUsage($filename,$mode) // generate possible abuse usage report
	{ 
		include "country_code.php";
        include "isp_code.php";
		$fpath = generateLogPath($filename);
		$total_input_size = 0; // total input traffic in bytes
		$total_output_size = 0; // total input traffic in bytes
		$date_range = array();
		$dns_cache = array();
		$users_ip_usage_count = array();
		$users_ip_list = array();
		$last_seen_onsite = array();
		$stime = microtime(true);
		$lines = file($fpath);
		$linecount = 0;
		if(isset($_SESSION['dns_cache']))
			$dns_cache_session = $_SESSION['dns_cache'];
		foreach($lines as $line_num => $line)
		{
			$linecount++;
			$line = trim($line);
			$tokens = csv_explode(" ",$line);
			$vald = substr($tokens[3],0,10);
			if(isset($_REQUEST['dateselbox_s']) == true && $_REQUEST['dateselbox_s'] != "")
				$start_date = $_REQUEST['dateselbox_s'];
			if(isset($_REQUEST['dateselbox_e']) == true && $_REQUEST['dateselbox_e'] != "")
				$end_date = $_REQUEST['dateselbox_e'];
			if(($vald >= $start_date && $vald <= $end_date) || (isset($start_date) == false && isset($end_date) == false))
			{
				$current_username = $tokens[1]; // username
				$garray = explode(",",$tokens[2]);
				if(count($garray) > 1)
					$current_group = $garray[0];  // group
				else
					$current_group = $tokens[2];  // group
				if($tokens[4] == "w" || $tokens[4] == "r" || $tokens[4] == "l" || $tokens[4] == "e" || $tokens[4] == "m" || $tokens[4] == "d" || $tokens[4] == "s")
				{
						if(isset($users_ip_list[$current_username]) == false)
						{
							$users_ip_usage_count[$current_username] = 1;
							$users_ip_list[$current_username] = array(1 => $tokens[0]); // must start from 1 index -- warning
						}
						else
						{
							$tmparr  = $users_ip_list[$current_username];
							if(array_search($tokens[0],$tmparr) == false)
							{
								array_push($tmparr,$tokens[0]);
								$users_ip_usage_count[$current_username] = count($tmparr);
								$users_ip_list[$current_username] = $tmparr;
							}
						}
				}
			}
		}
		$etime = microtime(true);
		$str_lines               = $linecount;
        $str_time_taken          = round(($etime - $stime),3) . " s";
		$str_size_logfile        = byte_format(filesize($fpath));
        
        // New info
        echo '<div class="info">';
        echo '<table id="gridInfo" class="gridInfo" border="0" cellspacing="0" cellpadding="0"><thead><tr><td width="400">Information</td><td width="100">Value</td></tr></thead><tbody>';
        echo "<tr><td>Total number of lines in LOG file</td><td>$linecount</td></tr>\n";
        //echo "<tr><td>Time taken for analysis</td><td>$str_time_taken</td></tr>\n";
        echo "<tr><td>LOG file size</td><td>$str_size_logfile</td></tr>\n";
        echo '</tbody></table>';   
        echo '</div>';
          
		echo "<H3>Users and IP addresses</H3>";
		
        $counter = 0;
		arsort($users_ip_usage_count);
        echo '<div class="gridcontainer">';
        echo '<table id="grid1" class="grid" border="0" cellspacing="0" cellpadding="0"><thead><tr><td width="50"><div class="mycenter">No.</div></td><td width="120">Username</td><td width="120">IP addr.</td><td>Host name</td><td>Country</td></tr></thead><tbody>';
		foreach($users_ip_usage_count as $key => $val)
		{
			$counter++;
			if($counter == 1 || $counter == 2 || $counter == 3)
				$itag = "<div class='medal$counter'></div>";
			else
				$itag = "<div class='rank'>$counter</div>";
			if($val <= 1)
				$ipk = "IP";
			else
				$ipk = "IPs";
			echo "<tr><td>$itag</td><td><div class='path'>$key" . "@" . $val . " $ipk</div></td><td> </td><td> </td><td> </td></tr>";
			asort($users_ip_list[$key]);
			foreach($users_ip_list[$key] as $key2 => $val2)
			{
				if(isPrivateIP($val2) == false)
				{
					if(isset($dns_cache_session))
					{
						$test = isset($dns_cache_session[$val2]);
                        if(isset($dns_cache_session[$val2]) == true)
                        {  $r_hostname = $dns_cache_session[$val2]; }
                        else
						{ $r_hostname = gethostbyaddr($val2); 
                        }
					}
					else
                    { $r_hostname = gethostbyaddr($val2); 
                    }
				}
				else
                {  $r_hostname = "Intranet"; }
                $dns_cache[$val2] = $r_hostname;
				$dmarr = explode(".",$r_hostname);
				$dma = " ";
				if(count($dmarr) > 1)
				{
					$lastcnt = count($dmarr) - 1;
					$lastdm = $dmarr[$lastcnt];
					if(isset($countrycode[$lastdm]) == true)
						{ $dma = $countrycode[$lastdm]; }
                    else if(count($dmarr) > 2) {
                        $beforelastcnt = count($dmarr) - 2;
                        $beforelastdm = $dmarr[$beforelastcnt] . "." . $dmarr[$beforelastcnt + 1];
                        if(isset($ispcode[$beforelastdm]) == true)
                        { $dma = $ispcode[$beforelastdm]; }
                    }
                }
				echo "<tr><td>&nbsp;</td><td><div class='path'>&nbsp;</div></td><td>$val2</td><td>$r_hostname</td><td>$dma</td></tr>";
			}
		}
		echo '</tbody></table>';
        echo '</div>';

		if(isset($_SESSION['dns_cache']) == false)
			$_SESSION['dns_cache'] = $dns_cache;
		else
			$_SESSION['dns_cache'] = array_merge($_SESSION['dns_cache'],$dns_cache);
            
        echo '<div class="page_foot">Page generated in ' . round((microtime(true) - $stime),3) . 's.<div/>';
	}

    function genFilteredLogList($filename) // generate filtered extraction
    {
        global $maxresults;
        global $subfolderignore; 
        $users = array();
        $groups = array();
        $actions = array();
        
        if(isset($_REQUEST['op']) == true && $_REQUEST['op'] != ""){
            $op = $_REQUEST['op']; }
        else { $op = ""; }
        if(isset($_REQUEST['users']) == true && $_REQUEST['users'] != ""){
            $users = explode ("|",$_REQUEST['users']); }
        else { $users[0] = '#ALL#'; } 
        if(isset($_REQUEST['groups']) == true && $_REQUEST['groups'] != "") {
            $groups = explode ("|",$_REQUEST['groups']); }
        else { $groups[0] = '#ALL#'; }
        if(isset($_REQUEST['actions']) == true && $_REQUEST['actions'] != "") {
            $actions = explode ("|",$_REQUEST['actions']); }
        else { $actions = array(); }
        if(isset($_REQUEST['groupfolder']) == true && $_REQUEST['groupfolder'] != "") {
            $groupfolder = $_REQUEST['groupfolder']; }
        else { $groupfolder = 'true'; }
        if(isset($_REQUEST['foldertimestamp']) == true && $_REQUEST['foldertimestamp'] != "") {
            $foldertimestamp = $_REQUEST['foldertimestamp']; }
        else { $foldertimestamp = 'last'; }
        if(isset($_REQUEST['orderacend']) == true && $_REQUEST['orderacend'] != "") {
            $orderacend = $_REQUEST['orderacend']; }
        else { $orderacend = 'false'; }
        if(isset($_REQUEST['orderby']) == true && $_REQUEST['orderby'] != "") {
            $orderby = $_REQUEST['orderby']; }
        else { $orderby = '0'; }
        if(isset($_REQUEST['filtermask']) == true && $_REQUEST['filtermask'] != "") {
            $filtermask = $_REQUEST['filtermask']; }
        else { $filtermask = ''; }
                
        // build the preg mask
        $pregmask = pattern_to_preg($filtermask);
        
        $fpath = generateLogPath($filename);
        $date_range = array();
        $filteredArray = array();
        $groupingArray = array();
        $stime = microtime(true);
        $lines = file($fpath);
        $linecount = 0;
        $ecount = 0;
        $cnt = 0;
        $counter = 0;
        
        // Read the data
        //----------------------------------
        foreach($lines as $line_num => $line)
        {
            $linecount++;
            $line = trim($line);
            $tokens = csv_explode(" ",$line);
                $vald = substr($tokens[3],0,10);
                if(isset($_REQUEST['dateselbox_s']) == true && $_REQUEST['dateselbox_s'] != "")
                    $start_date = $_REQUEST['dateselbox_s'];
                if(isset($_REQUEST['dateselbox_e']) == true && $_REQUEST['dateselbox_e'] != "")
                    $end_date = $_REQUEST['dateselbox_e'];
                if(($vald >= $start_date && $vald <= $end_date) || (isset($start_date) == false && isset($end_date) == false))
                {
                    if ((in_array($tokens[1],$users)) || ($users[0] == "#ALL#"))
                    {
                        $matchedgroup = false;
                        foreach (explode(",",$tokens[2]) as $group) {
                           if ((in_array($group,$groups)) || ($groups[0] == "#ALL#")){
                               $matchedgroup = true;
                               break; }}
                        if ($matchedgroup == true) {
                            $command = getCommand($tokens[4]);
                            if ((in_array(strtolower($command),$actions)) && (count($actions) != 0)) {
                                if ($groupfolder == "files") {
                                    //match filter
                                    if (preg_match($pregmask,$tokens[5])) {
                                         $filteredArray[$ecount] = $line;
                                         $ecount++; 
                                    }
                                }
                                elseif (($tokens[4] == 'r') || ($tokens[4] == 'w'))
                                {
                                    $path = basepath($tokens[5],$subfolderignore);
                                    
                                    if (preg_match($pregmask,$path)) {
                                       $groupkey =  $tokens[1] . "-" .  $path;
                                       $exists = array_key_exists($groupkey,$groupingArray);
                                       if ($exists == true) {                       
                                               if (($groupingArray[$groupkey][4] == $tokens[4]) && (samepaths($groupingArray[$groupkey][5],$tokens[5],$subfolderignore))) {
                                                   //Calc avg
                                                   if (($groupingArray[$groupkey][6] + $tokens[6]) != 0)
                                                   {
                                                       $groupingArray[$groupkey][7] = (($groupingArray[$groupkey][7] * $groupingArray[$groupkey][6]) + ($tokens[7] * $tokens[6]))/($groupingArray[$groupkey][6] + $tokens[6]);
                                                   }
                                                   
                                                   //Update size
                                                   $groupingArray[$groupkey][6] = $groupingArray[$groupkey][6] + $tokens[6];
                                                   //update count
                                                   $groupingArray[$groupkey][9] = $groupingArray[$groupkey][9] + 1; 
                                                   //update Filenames
                                                   $groupingArray[$groupkey][10] = $groupingArray[$groupkey][10] . "\n" . basename($tokens[5]);
                                                   //update Timestamp
                                                   $groupingArray[$groupkey][8] = $tokens[3];
                                               }
                                       }                  
                                       else {
                                            //first
                                            $tokens[8] = $tokens[3];
                                            $tokens[9] = 1;
                                            $tokens[10] = basename($tokens[5]);
                                            $tokens[11] = $path;
                                            $groupingArray[$groupkey] = $tokens;
                                       }
                                    } 
                                }
                            }
                        }
                    }
                }    
        }
            
        //if "last file" date is used, the list is not ordered !!
        //-----------------------------------------------------
         if (strtolower($foldertimestamp) == "last")
         { 
           $arrtimestamp = array_map('col_8', $groupingArray);  
         }
         else {
              $arrtimestamp = array_map('col_3', $groupingArray);
         }
        $arrcount = array_map('col_9', $groupingArray);
        $arrsize = array_map('col_6', $groupingArray);
        $arrname  =  array_map('col_11', $groupingArray);;

        // set the ordering array
        if (strtolower($orderby) == 'count') { $arr1 = $arrcount; }
        else if (strtolower($orderby) == 'size') { $arr1 = $arrsize; }
        else if (strtolower($orderby) == 'name') { $arr1 = $arrname; }
        else { $arr1 = $arrtimestamp; }

        // set the sort order
        if (strtolower($orderacend) == 'true') { 
            array_multisort($arr1, SORT_ASC, $groupingArray); }
        else { 
            array_multisort($arr1, SORT_DESC, $groupingArray); }
        
        $etime = microtime(true);
        $str_lines               = $linecount;
        $str_time_taken          = round(($etime - $stime),3) . " s";
        $str_size_logfile        = byte_format(filesize($fpath));
        
        
        // Output info if op 15 or 17
        //-----------------------------------------------------
          if (($op=="showfoldersdl") || ($op == "showfoldersul")) {
                echo '<div class="info">';
                echo '<table id="gridInfo" class="gridInfo" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=300>Information</td><td width=100>Value</td></tr></thead><tbody>';
                echo "<tr><td>Total number of lines in LOG file</td><td>$linecount</td></tr>\n";
                //echo "<tr><td>Time taken for analysis</td><td>$str_time_taken</td></tr>\n";
                echo "<tr><td>LOG file size</td><td>$str_size_logfile</td></tr>\n";
                echo "<tr><td>Max Results</td><td>$maxresults</td></tr>\n";
                echo '</tbody></table>';   
                echo '</div>';    
          }
 
        // Now we process
        //-----------------------------------------------------
        $counter = 0;
        
          if ($groupfolder == "files") {
             $totalecount = count($filteredArray);    
             if ($totalecount > $maxresults) {$showed = $maxresults; } 
             else {$showed = $totalecount; }   
             echo "<h3>Filtered list - " . $showed . " of " .  $totalecount . " entries</h3>";
             echo '<div class="gridcontainer">';
             echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td style="text-align:center">No.</td><td align:center>IP</td><td>User</td><td>Timestamp</td><td style="text-align:center">Action</td><td >Param 1</td><td>Param 2</td><td>Param 3</td></tr></thead><tbody>';
                for($i=0;$i<=$totalecount - 1 ;$i++)
                {
                    $counter++;
                    if (strtolower($orderacend) == 'true') { $thiscount = $i; }
                    else { $thiscount = $totalecount - $i - 1; }
                    
                    $tokens = csv_explode(" ",$filteredArray[$thiscount]);

                    $command = getCommand($tokens[4]);
                    $ts = clear_timestamp($tokens[3]);
                    if ((strtolower($command) == "login") || (strtolower($command) == "create") || (strtolower($command) == "delete") || (strtolower($command) == "error") || (strtolower($command) == "sitecmd")) {
                        echo "<tr><td style='text-align:center'>$counter</td><td>$tokens[0]</td><td title='$tokens[2]'>$tokens[1]</td><td white-space: nowrap>$ts</td><td style='text-align:center'>$command</td><td>$tokens[5]</td><td></td><td></td></tr>\n"; }
                    elseif ((strtolower($command) == "upload") || (strtolower($command) == "download")) {
                        echo "<tr><td style='text-align:center'>$counter</td><td>$tokens[0]</td><td title='$tokens[2]'>$tokens[1]</td><td white-space: nowrap>$ts</td><td style='text-align:center'>$command</td><td>$tokens[5]</td><td white-space: nowrap style='text-align:right'>" . byte_format($tokens[6]) . "</td><td white-space: nowrap style='text-align:right'>" . kbs_format($tokens[7],2) . "</td></tr>\n"; }
                    elseif ((strtolower($command) == "ask") || (strtolower($command) == "exec") || (strtolower($command) == "file") || (strtolower($command) == "log") || (strtolower($command) == "http") || (strtolower($command) == "queue")) {
                        $cmdstr = substr($tokens[4],strlen($command)+3);
                        $cmdparams = "";
                        $pos = strposOffset(" ",$filteredArray[$thiscount],4); 
                        $cmdparams = substr($filteredArray[$thiscount],$pos);
                        echo "<tr><td style='text-align:center'>$counter</td><td>$tokens[0]</td><td title='$tokens[2]'>$tokens[1]</td><td white-space: nowrap>$ts</td><td style='text-align:center'>$command</td><td>$cmdstr</td><td>$cmdparams</td><td></td></tr>\n"; }
                          
                    if($i >= intval($maxresults))
                        break;
                }
                echo '</tbody></table>';
                echo '</div>';
                echo '<div class="page_foot">Page generated in ' . round((microtime(true) - $stime),3) . 's.<div/>';
          }
          else {
             $totalecount = count($groupingArray);
             if ($totalecount > $maxresults) {$showed = $maxresults; } 
             else {$showed = $totalecount; }   
             echo "<h3>Folders - " . $showed . " of " .  $totalecount . " entries</h3>";
             echo '<div class="gridcontainer">';
             echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td  style="text-align:center">No.</td><td width="40">User</td><td width="120">Timestamp</td><td style="text-align:center" width="60">Action</td><td>Folder</td><td style="text-align:center">Files</td><td style="text-align:center">Size</td><td style="text-align:center">Avg.Speed</td></tr></thead><tbody>';
            
            $totalsize = 0;
            $totalfiles = 0;
            $avgspeed = 0;
                
                foreach ($groupingArray as $key => $val) 
                {
                    $counter++;
                    
                    $thiscount = $totalecount - $counter;
                    $tokens = $val;
                    $command = getCommand($tokens[4]);
                    if ((strtolower($command) == "upload") || (strtolower($command) == "download")) {
                        if (strlen($tokens[10]) >= 512) {
                            $tmpstr = substr($tokens[10],0,508);
                            $lastpos = strrpos($tmpstr,"\n", -0);
                            if ($lastpos > 0) { $files = substr($tmpstr,0,$lastpos) . "\n..."; }
                        }    
                        else { $files = $tokens[10]; }
                        
                         if (strtolower($foldertimestamp) == "last") { $ts = clear_timestamp($tokens[8]); }
                         else {$ts = clear_timestamp($tokens[3]);}
                        
                        echo "<tr><td style='text-align:center'>$counter</td><td title='$tokens[2]'>$tokens[1]</td><td Title='Start: " . clear_timestamp($tokens[3]) . "\nEnd: " . clear_timestamp($tokens[8]) . "' white-space: nowrap>$ts</td><td style='text-align:center'>$command</td><td title='$files'>" . basepath($tokens[5],$subfolderignore) . '</td><td white-space: nowrap style="text-align:right" >' . $tokens[9] .'</td><td white-space: nowrap style="text-align:right">' . byte_format($tokens[6]) . '</td><td white-space: nowrap style="text-align:right">' . kbs_format($tokens[7],2) . '</td></tr>'; 
               
                        $totalsize += $tokens[6];
                        $totalfiles += $tokens[9];
                        $avgspeed += ($tokens[6]*$tokens[7]);
                       
                   }
                    if($counter >= intval($maxresults)) { break; }
                }
                
                if($counter > 0) {
                    $bstyle  = 'style="border-top: 1px solid #BAC4CC; text-align:right"';
                    $bstyler = 'style="text-align:right"';
                    if ($totalecount > 0) {$avgspeed = $avgspeed/$totalsize; }
                    echo '<tr><td></td><td></td><td></td><td></td><td '.$bstyler.'>Total: </td><td white-space: nowrap '.$bstyle.'>' . $totalfiles .'</td><td white-space: nowrap '.$bstyle.'>' . byte_format($totalsize) . '</td><td '.$bstyle.'>'. kbs_format($avgspeed,2) .'</td></tr>'; 
                    
                    //echo '<tr><td></td><td></td><td></td><td></td><td '.$bstyler.'>Avegage: </td><td white-space: nowrap '.$bstyle.'>' . intval($totalfiles/$counter) .'</td><td white-space: nowrap '.$bstyle.'>' . byte_format($totalsize/$counter) . '</td><td '.$bstyle.'>'. kbs_format($avgspeed,2) .'</td></tr>'; 
                }
                echo '</tbody></table>';
                echo '</div>';
                echo '<div class="page_foot">Page generated in ' . round((microtime(true) - $stime),3) . 's.<div/>';
          }
    }
    
    function genLogList($filename,$mode) // generate base extraction
	{
		global $maxresults;
        $keyword = "e";
		if($mode == 6)
			$keyword = "e";
		else if($mode == 7)
			$keyword = "d";
		else if($mode == 8)
			$keyword = "s";
		else if($mode == 9)
			$keyword = "l";
		else if($mode == 10)
			$keyword = "m";
		else if($mode == 11)
			$keyword = "w";
		else if($mode == 12)
			$keyword = "r";
        else if($mode == 14)
            $keyword = "ask";
        else
            die("<div class='info'>Unknown Mode requested.</div>");
            
		$fpath = generateLogPath($filename);
		$date_range = array();
		$errorsArray = array();
		$stime = microtime(true);
		$lines = file($fpath);
		$linecount = 0;
		$ecount = 0;
		foreach($lines as $line_num => $line)
		{
			$linecount++;
			$line = trim($line);
			$tokens = csv_explode(" ",$line);
			    $vald = substr($tokens[3],0,10);
			    if(isset($_REQUEST['dateselbox_s']) == true && $_REQUEST['dateselbox_s'] != "")
				    $start_date = $_REQUEST['dateselbox_s'];
			    if(isset($_REQUEST['dateselbox_e']) == true && $_REQUEST['dateselbox_e'] != "")
				    $end_date = $_REQUEST['dateselbox_e'];
			    if(($vald >= $start_date && $vald <= $end_date) || (isset($start_date) == false && isset($end_date) == false))
			    {
				    if ($mode == 14)
                    {
                        if((substr($tokens[4],0,4) == "ask:") || (substr($tokens[4],0,5) == "exec:") || (substr($tokens[4],0,5) == "file:") || (substr($tokens[4],0,5) == "http:") || (substr($tokens[4],0,4) == "log:") || (substr($tokens[4],0,6) == "queue:")) // extract log entries
                        {
                            $errorsArray[$ecount] = $line;
                            $ecount++;
                        }        
                    }
                    elseif($tokens[4] == $keyword) // extract log entries
				    {
					    $errorsArray[$ecount] = $line;
						$ecount++;
				    }
			    }
		}
		$etime = microtime(true);
		
		$str_lines               = $linecount;
		$str_time_taken          = round(($etime - $stime),3) . " s";
		$str_size_logfile        = byte_format(filesize($fpath));
		
        // New info
        echo '<div class="info">';
        echo '<table id="gridInfo" class="gridInfo" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=300>Information</td><td width=100>Value</td></tr></thead><tbody>';
        echo "<tr><td>Total number of lines in LOG file</td><td>$linecount</td></tr>\n";
        //echo "<tr><td>Time taken for analysis</td><td>$str_time_taken</td></tr>\n";
        echo "<tr><td>LOG file size</td><td>$str_size_logfile</td></tr>\n";
        echo "<tr><td>Max Results</td><td>$maxresults</td></tr>\n";
        echo '</tbody></table>';   
        echo '</div>';
		
        $counter = 0;
		$totalecount = count($errorsArray);
        
        if ($totalecount > $maxresults) {$showed = $maxresults; } 
        else {$showed = $totalecount; }   
        
		if($mode == 7 || $mode == 10)
		{
			if ($mode == 7)
            {
                echo "<h3>Deleted Items - " . $showed . " of " .  $totalecount . " entries</h3>";
            }
            else if($mode == 10)
            {
                echo "<h3>Folder Creates - " . $showed . " of " .  $totalecount . " entries</h3>";
            }
            echo '<div class="gridcontainer">';
            echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width="40"><div class="mycenter">No.</div></td><td width="120">IP addr.</td><td width="40">Username</td><td width="120">Timestamp</td><td>Path</td></tr></thead><tbody>';
			for($i=1;$i<=$totalecount;$i++)
			{
				$counter++;
				$thiscount = $totalecount - $i;
				$tokens = csv_explode(" ",$errorsArray[$thiscount]);
				echo "<tr><td><div class='rank'>$counter</div></td><td>$tokens[0]</td><td title='group: " . $tokens[2] . "'>$tokens[1]</td><td white-space: nowrap>" . clear_timestamp($tokens[3]) . "</td><td>$tokens[5]</td></tr>\n";
				if($i >= intval($maxresults))                                                                                                                          
					break;
			}
			echo '</tbody></table>';
            echo '</div>';
            
		}
		else if($mode == 9)
		{
            echo "<h3>Logins - " . $showed . " of " .  $totalecount . " entries</h3>";
			echo '<div class="gridcontainer">';
            echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width="40"><div class="mycenter">No.</div></td><td width="120">IP addr.</td><td width="40">Username</td><td width="120">Timestamp</td><td>Information</td></tr></thead><tbody>';
			for($i=1;$i<=$totalecount;$i++)
			{
				$counter++;
				$thiscount = $totalecount - $i;
				$tokens = csv_explode(" ",$errorsArray[$thiscount]);
				echo "<tr><td><div class='rank'>$counter</div></td><td>$tokens[0]</td><td title='group: " . $tokens[2] . "'>$tokens[1]</td><td white-space: nowrap>" . clear_timestamp($tokens[3]) . "</td><td>$tokens[5]</td></tr>\n";
				if($i >= intval($maxresults))
					break;
			}
			echo '</tbody></table>';
            echo '</div>';
            
		}
		else if($mode == 8)
		{
			echo "<h3>Site Commands - " . $showed . " of " .  $totalecount . " entries</h3>";
            echo '<div class="gridcontainer">';
            echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width="40"><div class="mycenter">No.</div></td><td width="120">IP addr.</td><td width="40">Username</td><td width="120">Timestamp</td><td>Command line</td></tr></thead><tbody>';
			for($i=1;$i<=$totalecount;$i++)
			{
				$counter++;
				$thiscount = $totalecount - $i;
				$tokens = csv_explode(" ",$errorsArray[$thiscount]);
				echo "<tr><td><div class='rank'>$counter</div></td><td>$tokens[0]</td><td title='group: " . $tokens[2] . "'>$tokens[1]</td><td white-space: nowrap>" . clear_timestamp($tokens[3]) . "</td><td title='cmd: " . $tokens[5] . "'>$tokens[5]</td></tr>\n";
				if($i >= intval($maxresults))
					break;
			}
			echo '</tbody></table>';
            echo '</div>';
            
		}
		else if($mode == 6)
		{
			echo "<h3>FTP Errors - " . $showed . " of " .  $totalecount . " entries</h3>";
            echo '<div class="gridcontainer">';
            echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width="40"><div class="mycenter">No.</div></td><td width="120">IP addr.</td><td width="40">Username</td><td width="120">Timestamp</td><td>Error</td></tr></thead><tbody>';
			for($i=1;$i<=$totalecount;$i++)
			{
				$counter++;
				$thiscount = $totalecount - $i;
				$tokens = csv_explode(" ",$errorsArray[$thiscount]);
				echo "<tr><td><div class='rank'>$counter</div></td><td>$tokens[0]</td><td title='group: " . $tokens[2] . "'>$tokens[1]</td><td white-space: nowrap>" . clear_timestamp($tokens[3]) . "</td><td>$tokens[5]</td></tr>\n";
				if($i >= intval($maxresults))
					break;
			}
			echo '</tbody></table>';
            echo '</div>';
            
		}
        else if($mode == 14)
        {
            echo "<h3>FTP Ask & Exec - " . $showed . " of " .  $totalecount . " entries</h3>";
            
            echo '<div class="gridcontainer">';
            echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td><div class="mycenter" width="40">No.</div></td><td width="120">IP addr.</td><td width="40">Username</td><td width="120">Timestamp</td><td><div class="mycenter">Command</div></td><td>Command Parameters</td></tr></thead><tbody>';
            for($i=1;$i<=$totalecount;$i++)
            {
                $counter++;
                $thiscount = $totalecount - $i;
                $tokens = csv_explode(" ",$errorsArray[$thiscount]);
                if(substr($tokens[4],0,6) == "ask://")
                {
                    $command =  "Ask";
                }
                elseif(substr($tokens[4],0,7) == "exec://")
                {
                    $command =  "Exec";    
                }
                elseif(substr($tokens[4],0,7) == "file://")
                {
                    $command =  "File";    
                }
                elseif(substr($tokens[4],0,7) == "http://")
                {
                    $command =  "Http";    
                }
                if(substr($tokens[4],0,6) == "log://")
                {
                    $command =  "Log";
                }
                elseif(substr($tokens[4],0,8) == "queue://")
                {
                    $command =  "Queue";    
                }
                $cmdstring = "";
                for($cnt=4;$cnt<sizeof($tokens);$cnt++)
                    {
                       $cmdstring = $cmdstring . " "  .  $tokens[$cnt];
                    } 
                echo "<tr><td><div class='rank'>$counter</div></td><td>$tokens[0]</td><td title='group: " . $tokens[2] . "'>$tokens[1]</td><td white-space: nowrap>" . clear_timestamp($tokens[3]) . "</td><td><div class='mycenter'>$command</div></td><td title='Parameters: " . $cmdstring . "'>$cmdstring</td></tr>\n";
                if($i >= intval($maxresults))
                    break;
            }
            echo '</tbody></table>';
            echo '</div>';
            
        }
		else if (($mode == 11) || ($mode == 12))
		{
			if ($mode == 11)
            {
                echo "<h3>File Uploads - " . $showed . " of " .  $totalecount . " entries</h3>";
            }
            else if($mode == 12)
            {
                echo "<h3>File Downloads - " . $showed . " of " .  $totalecount . " entries</h3>";
            }
            echo '<div class="gridcontainer">';
            echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td><div class="mycenter" width="40">No.</div></td><td width="120">IP addr.</td><td width="40">Username</td><td width="120">Timestamp</td><td>Path</td><td white-space: nowrap width="60" style="text-align:center">Size</td><td width="60" style="text-align:center">Speed</td></tr></thead><tbody>';
			for($i=1;$i<=$totalecount;$i++)
			{
				$counter++;
				$thiscount = $totalecount - $i;
				$tokens = csv_explode(" ",$errorsArray[$thiscount]);
				echo "<tr><td><div class='rank'>$counter</div></td><td>$tokens[0]</td><td title='group: " . $tokens[2] . "'>$tokens[1]</td><td white-space: nowrap>" . clear_timestamp($tokens[3]) . "</td><td>$tokens[5]</td><td white-space: nowrap style='text-align:right'>" . byte_format($tokens[6]) . "</td><td white-space: nowrap style='text-align:right'>" . kbs_format($tokens[7]) . "</td></tr>\n";
				if($i >= intval($maxresults))
					break;
			}
			echo '</tbody></table>';
            echo '</div>';
            
        }
        else {}
        echo '<div class="page_foot">Page generated in ' . round((microtime(true) - $stime),3) . 's.<div/>';
	}
    
    function genTopstatistics($filename) // generate Top Stats
    {
        global $topsize;
        global $subfolderignore;
        $fpath = generateLogPath($filename);
        $total_input_size = 0; // total input traffic in bytes
        $total_output_size = 0; // total input traffic in bytes
        $date_range = array();
        $user_logins = array();
        $group_logins = array();
        $user_to_group_map = array();
        $user_upload_bytes = array();
        $user_download_bytes = array();
        $group_upload_bytes = array();
        $group_download_bytes = array();
        $user_upload_hits = array();
        $user_download_hits = array();
        $group_upload_hits = array();
        $group_download_hits = array();
        $stime = microtime(true);
        $lines = file($fpath);
        $linecount = 0;
        
        //Top Array
        //key:User/group [0]:value [1]:arrayfolders [2]:files
        
        foreach($lines as $line_num => $line)
        {
            $linecount++;
            $line = trim($line);
            $tokens = csv_explode(" ",$line);
            $vald = substr($tokens[3],0,10);
            if(isset($_REQUEST['dateselbox_s']) == true && $_REQUEST['dateselbox_s'] != "")
                $start_date = $_REQUEST['dateselbox_s'];
            if(isset($_REQUEST['dateselbox_e']) == true && $_REQUEST['dateselbox_e'] != "")
                $end_date = $_REQUEST['dateselbox_e'];
            if(($vald >= $start_date && $vald <= $end_date) || (isset($start_date) == false && isset($end_date) == false))
            {
                $current_username = $tokens[1]; // username
                $garray = explode(",",$tokens[2]);
                if(count($garray) > 1)
                    $current_group = $garray[0];  // group
                else
                    $current_group = $tokens[2];  // group
                $user_to_group_map[$current_username] = $current_group;
                
                if($tokens[4] == "w") // make top uploaders
                {
                    if(count($tokens) == 8)
                    {
                        if(is_numeric($tokens[6])) // input size in bytes
                        {
                            $total_input_size = $total_input_size + $tokens[6];
                            $spath = basepath($tokens[5],$subfolderignore);
                            if(isset($user_upload_bytes[$current_username]) == false)
                            {
                                $user_upload_bytes[$current_username][0] = $tokens[6];
                                $user_upload_bytes[$current_username][1] = array(0 => $spath);
                                $user_upload_bytes[$current_username][2] = 1;
                            }    
                            else
                            {   $user_upload_bytes[$current_username][0] = $user_upload_bytes[$current_username][0] + $tokens[6];
                                if (in_array($spath,$user_upload_bytes[$current_username][1]) == false)
                                { array_push($user_upload_bytes[$current_username][1], $spath); }
                                $user_upload_bytes[$current_username][2] = $user_upload_bytes[$current_username][2] + 1;
                            }    
                                 
                            if(isset($group_upload_bytes[$current_group]) == false)
                            {    $group_upload_bytes[$current_group][0] = $tokens[6];
                                $group_upload_bytes[$current_group][1] = array(0 => $spath);
                                $group_upload_bytes[$current_group][2] = 1;
                            }
                            else
                            {    $group_upload_bytes[$current_group][0] = $group_upload_bytes[$current_group][0] + $tokens[6];
                                if (in_array($spath,$group_upload_bytes[$current_group][1]) == false)
                                { array_push($group_upload_bytes[$current_group][1], $spath); }
                                $group_upload_bytes[$current_group][2] = $group_upload_bytes[$current_group][2] + 1;
                        
                            }
                        }
                    }
                }
                else if($tokens[4] == "r") // input traffic
                {
                    if(count($tokens) == 8)
                    {
                        if(is_numeric($tokens[6])) // output size in bytes
                        {
                            $total_output_size = $total_output_size + $tokens[6];
                            $spath = basepath($tokens[5],$subfolderignore);
                            if(isset($user_download_bytes[$current_username]) == false)
                            {
                                $user_download_bytes[$current_username][0] = $tokens[6];
                                $user_download_bytes[$current_username][1] = array(0 => $spath);
                                $user_download_bytes[$current_username][2] = 1;
                            }    
                            else
                            {   $user_download_bytes[$current_username][0] = $user_download_bytes[$current_username][0] + $tokens[6];
                                if (in_array($spath,$user_download_bytes[$current_username][1]) == false)
                                { array_push($user_download_bytes[$current_username][1], $spath); }
                                $user_download_bytes[$current_username][2] = $user_download_bytes[$current_username][2] + 1;
                            }    
                                 
                            if(isset($group_download_bytes[$current_group]) == false)
                            {    $group_download_bytes[$current_group][0] = $tokens[6];
                                 $group_download_bytes[$current_group][1] = array(0 => $spath);
                                 $group_download_bytes[$current_group][2] = 1;
                            }
                            else
                            {   $group_download_bytes[$current_group][0] = $group_download_bytes[$current_group][0] + $tokens[6];
                                if (in_array($spath,$group_download_bytes[$current_group][1]) == false)
                                { array_push($group_download_bytes[$current_group][1], $spath); }
                                $group_download_bytes[$current_group][2] = $group_download_bytes[$current_group][2] + 1;
                            }
                        }
                    }
                }
                else if ($tokens[4] == "l")
                {
                    if(isset($user_logins[$current_username]) == false)
                        { $user_logins[$current_username] = 1; }    
                    else
                        { $user_logins[$current_username] = $user_logins[$current_username] + 1; } 
                    
                    if(isset($group_logins[$current_group]) == false)
                        { $group_logins[$current_group] = 1; }    
                    else
                        { $group_logins[$current_group] = $group_logins[$current_group] + 1; }     
                    
                }
            }
        }
        $etime = microtime(true);
        $str_lines               = $linecount;
        $str_time_taken          = round(($etime - $stime),3) . " s";
        $str_size_logfile        = byte_format(filesize($fpath));
        $str_total_upload_size   = byte_format($total_input_size);
        $str_total_download_size = byte_format($total_output_size);
        
         echo '<div class="info">';
        // New info
        echo '<table id="gridInfo" class="gridInfo" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=400>Information</td><td width=100>Value</td></tr></thead><tbody>';
        echo "<tr><td>Total number of lines in LOG file</td><td>$linecount</td></tr>\n";
        //echo "<tr><td>Time taken for analysis</td><td>$str_time_taken</td></tr>\n";
        echo "<tr><td>LOG file size</td><td>$str_size_logfile</td></tr>\n";
        echo "<tr><td>Total input size</td><td>$str_total_upload_size</td></tr>\n";
        echo "<tr><td>Total output size</td><td>$str_total_download_size</td></tr>\n";
        echo '</tbody></table>';   
        // 
        echo '</div>';
        
         arsort($user_upload_bytes);
        $counter = 0;
        echo "<h3>Top$topsize - Uploaders by Size</h3>";
        echo '<div class="gridcontainer">';
        echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0 style="width: 550px;"><thead><tr><td width=50 style="text-align:center">No.</td><td width=120>Username</td><td width=120>Group</td><td width=60 style="text-align:center">Transfer</td><td width=160 style="text-align:center">Percentage</td></tr></thead><tbody>';
        foreach($user_upload_bytes as $key => $val)
        {
            $counter++;
            if($counter == 1 || $counter == 2 || $counter == 3)
                $itag = "<div class='medal$counter'></div>";
            else
            { $itag = "<div class='rank'>$counter</div>"; }
              
            $folders = count($val[1]);
            $files   = $val[2];
            if(isset($user_logins[$key]) == true)
                { $logins = $user_logins[$key]; }
            else { $logins = 0; }
               
            echo "<tr><td>$itag</td><td title='Logins: $logins'>$key</td><td>" . $user_to_group_map[$key] . "</td><td title='Folders: $folders\nFiles: $files' style='text-align:right'>" . byte_format($val[0]) . "</td><td style='background: transparent url(ratingbar.php?rating=" . round($val[0]/$total_input_size,4)*100 . ") no-repeat 5px center; padding-left: 120px;'>". round($val[0]/$total_input_size,4)*100 ."%</td></tr>";
        }
        echo '</tbody></table>';
        echo '</div>';
        arsort($user_download_bytes);
        $counter = 0;
        echo "<h3>Top$topsize - Downloaders by Size</h3>";
        echo '<div class="gridcontainer">';
        echo '<table id="grid2" class="grid" border=0 cellspacing=0 cellpadding=0 style="width: 550px;"><thead><tr><td width=50 style="text-align:center">No.</td><td width=120>Username</td><td width=110>Group</td><td width=60 style="text-align:center">Transfer</td><td width=160 style="text-align:center">Percentage</td></tr></thead><tbody>';
        foreach($user_download_bytes as $key => $val)
        {
            $counter++;
            if($counter == 1 || $counter == 2 || $counter == 3)
                $itag = "<div class='medal$counter'></div>";
            else
            { $itag = "<div class='rank'>$counter</div>"; }
            
            $folders = count($val[1]);
            $files   = $val[2];
            
            $ret = in_array($key,$user_logins);
            if(isset($user_logins[$key]) == true)
                { $logins = $user_logins[$key]; }
            else { $logins = 0; }
            
            echo "<tr><td>$itag</td><td title='Logins: $logins'>$key</td><td>" . $user_to_group_map[$key] . "</td><td title='Folders: $folders\nFiles: $files' style='text-align:right'>" . byte_format($val[0]) . "</td><td style='background: transparent url(ratingbar.php?rating=" . round($val[0]/$total_output_size,4)*100 . ") no-repeat 5px center; padding-left: 120px;'>". round($val[0]/$total_output_size,4)*100 ."%</td></tr>";
        }
        echo '</tbody></table>';
        echo '</div>';
        arsort($group_upload_bytes);
        $counter = 0;
        echo "<h3>Top$topsize - Uploader Groups by Size</h3>";
        echo '<div class="gridcontainer">';
        echo '<table id="grid3" class="grid" border=0 cellspacing=0 cellpadding=0 style="width: 550px;"><thead><tr><td width=50 style="text-align:center">No.</td><td width=230>Group</td><td width=60 style="text-align:center">Transfer</td><td width=160 style="text-align:center">Percentage</td></tr></thead><tbody>';
        foreach($group_upload_bytes as $key => $val)
        {
            $counter++;
            if($counter == 1 || $counter == 2 || $counter == 3)
                $itag = "<div class='medal$counter'></div>";
            else
                { $itag = "<div class='rank'>$counter</div>";}
                
                $folders = count($val[1]);
                $files   = $val[2];
                
                if(isset($group_logins[$key]) == true)
                { $logins = $group_logins[$key]; }
                else { $logins = 0; }
            
                echo "<tr><td>$itag</td><td title='Logins: $logins'>$key</td><td title='Folders: $folders\nFiles: $files' style='text-align:right'>" . byte_format($val[0]) . "</td><td style='background: transparent url(ratingbar.php?rating=" . round($val[0]/$total_input_size,4)*100 . ") no-repeat 5px center; padding-left: 120px;'>". round($val[0]/$total_input_size,4)*100 ."%</td></tr>";
        }
        echo '</tbody></table>';
        echo '</div>';
        arsort($group_download_bytes);
        $counter = 0;
        echo "<h3>Top$topsize - Downloader Groups by Size</h3>";
        echo '<div class="gridcontainer">';
        echo '<table id="grid4" class="grid" border=0 cellspacing=0 cellpadding=0 style="width: 550px;"><thead><tr><td width=50 style="text-align:center">No.</td><td width=230>Group</td><td width=60 style="text-align:center">Transfer</td><td width=160 style="text-align:center">Percentage</td></tr></thead><tbody>';
        foreach($group_download_bytes as $key => $val)
        {
            $counter++;
            if($counter == 1 || $counter == 2 || $counter == 3)
                $itag = "<div class='medal$counter'></div>";
            else
                { $itag = "<div class='rank'>$counter</div>"; }
            
            $folders = count($val[1]);
            $files   = $val[2];
            
            if(isset($group_logins[$key]) == true)
                { $logins = $group_logins[$key]; }
            else { $logins = 0; }
            echo "<tr><td>$itag</td><td title='Logins: $logins'>$key</td><td title='Folders: $folders\nFiles: $files' style='text-align:right'>" . byte_format($val[0]) . "</td><td style='background: transparent url(ratingbar.php?rating=" . round($val[0]/$total_output_size,4)*100 . ") no-repeat 5px center; padding-left: 120px;'>". round($val[0]/$total_output_size,4)*100 ."%</td></tr>";
            //<td style='text-align:center'>" . round($val[0]/$total_output_size,4)*100 . "%</td></tr>";
        }
        echo '</tbody></table>';
        echo '</div>';
        echo '<div class="page_foot">Page generated in ' . round((microtime(true) - $stime),3) . 's.<div/>';
    }

    function queryDateRange($filename) // generate logfile timestamps/users/groups
    {
        $fpath = generateLogPath($filename);
        $date_range = array();
        $users      = array();
        $groups     = array();
        $lines = file($fpath);
        $linecount = 0;
        foreach($lines as $line_num => $line)
        {
            $linecount ++;
            $line = trim($line);
            $tokens = csv_explode(" ",$line);
            
            if(count($tokens) >= 6)
            {
                $date1 = substr($tokens[3],0,10);
                if(isset($date_range[$date1]) == false) // there is Activity on this day
                $date_range[$date1] = $date1;
                
                //check users
                $user = substr($tokens[1],0);
                if (in_array($user,$users,true) == false)
                { array_push($users,$user); }
                
                //check groups
                $tmpgroups = substr($tokens[2],0);
                $gtokens = csv_explode(",",$tmpgroups);
                foreach($gtokens as $group)
                {
                   if (in_array($group,$groups,true) == false)
                   { array_push($groups,$group); } 
                }

            }
        }
        $curloglines = $linecount;
        $curlogsize  = filesize($fpath);
        $curlogname  = $filename;
        
        asort($date_range); // old date first
        // generating date selection box
        $acount = count($date_range);
        $loopcount = 0;
        $start_date = "";
        $end_date = "";
        $startcount = 0;

        $selbox_out_s = "<SELECT id='dateselbox_s' name='dateselbox_s' onChange=\"javascript:dateInputschanged(this);\">\n";
        foreach($date_range as $key => $val) // from selection box
        {
            if($loopcount == $startcount || $start_date == $val)
            {
                $start_date = $val;
                $selbox_out_s = $selbox_out_s . " <OPTION value='$val' SELECTED>$key</OPTION>\n";
            }
            else
                $selbox_out_s = $selbox_out_s . " <OPTION value='$val'>$key</OPTION>\n";
            $loopcount++;
        }
        $selbox_out_s = $selbox_out_s . "</SELECT> \n";
        arsort($date_range); // last date first
        $selbox_out_e = "<SELECT id='dateselbox_e' name='dateselbox_e' onChange=\"javascript:dateInputschanged(this);\">\n";
        foreach($date_range as $key => $val) // to selection box
        {
            if($end_date == "")
                $end_date = $val;
            if($end_date == $val)
                $selbox_out_e = $selbox_out_e . " <OPTION value='$val' SELECTED>$key</OPTION>\n";
            else
                $selbox_out_e = $selbox_out_e . " <OPTION value='$val'>$key</OPTION>\n";
        }
        $selbox_out_e = $selbox_out_e . "</SELECT> \n";
        echo "<table class='loggrid'><tr><td>From </td><td><img src='images/i_date.png' alt='' /></td><td><div id='container_s'>" . $selbox_out_s . "</div></td><td> to </td><td><img src='images/i_date.png' alt='' /></td><td><div id='container_e'>" . $selbox_out_e . "</div></td></tr></table>";
        
        //Write to session vars
        $_SESSION['currentlog']  = $curlogname . "|" . $linecount . "|" . $curlogsize  . "|" . $start_date   . "|" . $end_date; 
        $_SESSION['currentusers']  = $users;
        $_SESSION['currentgroups']  = $groups;
        session_commit();
     }

    function genHitoMeter($filename,$mode) // mode 4 dirs 5 files
    {
        global $topsize;
        global $subfolderignore;
        global $fileignore;
        
        $fpath = generateLogPath($filename);
        $total_input_size = 0; // total input traffic in bytes
        $total_output_size = 0; // total input traffic in bytes
        $date_range = array();
        $popularpaths_dl = array();
        $popularpaths_dlsize = array();
        $popularpaths_ul = array();
        $popularpaths_ulsize = array();
        $stime = microtime(true);
        $lines = file($fpath);
        $linecount = 0;
        foreach($lines as $line_num => $line)
        {
            $linecount++;
            $line = trim($line);
            $tokens = csv_explode(" ",$line);
            $vald = substr($tokens[3],0,10);
            if(isset($_REQUEST['dateselbox_s']) == true && $_REQUEST['dateselbox_s'] != "")
                $start_date = $_REQUEST['dateselbox_s'];
            if(isset($_REQUEST['dateselbox_e']) == true && $_REQUEST['dateselbox_e'] != "")
                $end_date = $_REQUEST['dateselbox_e'];
            if(($vald >= $start_date && $vald <= $end_date) || (isset($start_date) == false && isset($end_date) == false))
            {
                $current_username = $tokens[1]; // username
                $garray = explode(",",$tokens[2]);
                if(count($garray) > 1)
                    $current_group = $garray[0];  // group
                else
                    $current_group = $tokens[2];  // group
                if($tokens[4] == "w") // make top uploaders
                {
                    if(count($tokens) == 8)
                    {
                        if(is_numeric($tokens[6])) // input size in bytes
                        {
                            if($mode == 4)
                                $basepath = basepath($tokens[5],$subfolderignore); // path
                            else if($mode == 5)
                                $basepath = basename($tokens[5]); // file
                            if($basepath == "\\")
                                $basepath = "/";
                                
                            $regmask = pattern_to_preg($fileignore);
                            // $regmask = "#(?i:" . $fileignore . ")#";
                            if ((preg_match($regmask, $basepath) == 0) || ($fileignore == "") || ($mode == 4))
                            {
                                if(isset($popularpaths_ul[$basepath]) == false)
                                {   $popularpaths_ul[$basepath][0] = 1;
                                    $popularpaths_ul[$basepath][1][$tokens[1]] = array(0 => $tokens[3], 1 => $tokens[3]);
                                    $popularpaths_ul[$basepath][2] = $tokens[6];
                                }
                                else
                                {   $popularpaths_ul[$basepath][0]++;
                                    if (array_key_exists($tokens[1],$popularpaths_ul[$basepath][1]) == true)
                                    { $popularpaths_ul[$basepath][1][$tokens[1]][1] = $tokens[3]; }
                                    else
                                    { $popularpaths_ul[$basepath][1][$tokens[1]] = array(0 => $tokens[3], 1 => $tokens[3]); }
                                      $popularpaths_ul[$basepath][2] = $popularpaths_ul[$basepath][2] + $tokens[6];
                                }
                                
                                if(isset($popularpaths_ulsize[$basepath]) == false)
                                {   $popularpaths_ulsize[$basepath][0] = $tokens[6];
                                    $popularpaths_ulsize[$basepath][1][$tokens[1]] = array(0 => $tokens[3], 1 => $tokens[3]);
                                    $popularpaths_ulsize[$basepath][2] = 1;
                                }
                                else
                                {   $popularpaths_ulsize[$basepath][0] = $popularpaths_ulsize[$basepath][0] + $tokens[6];
                                    if (array_key_exists($tokens[1],$popularpaths_ulsize[$basepath][1]) == true)
                                    { $popularpaths_ulsize[$basepath][1][$tokens[1]][1] = $tokens[3]; }
                                    else
                                    { $popularpaths_ulsize[$basepath][1][$tokens[1]] = array(0 => $tokens[3], 1 => $tokens[3]); }
                                      $popularpaths_ulsize[$basepath][2] = $popularpaths_ulsize[$basepath][2] + 1;
                                }
                            }
                        }    
                    }
                }
                else if($tokens[4] == "r") // input traffic
                {
                    if(count($tokens) == 8)
                    {
                        if(is_numeric($tokens[6])) // output size in bytes
                        {
                            if($mode == 4)
                                $basepath = basepath($tokens[5],$subfolderignore); // path
                            else if($mode == 5)
                                $basepath = basename($tokens[5]); // file
                            if($basepath == "\\")
                                $basepath = "/";
                            
                            $regmask = pattern_to_preg($fileignore);
                            //$regmask = "#(?i:" . $fileignore . ")#"; 
                            if ((preg_match($regmask, $basepath) == 0) || ($fileignore == "") || ($mode == 4))
                            {
                                if(isset($popularpaths_dl[$basepath]) == false)
                                {   $popularpaths_dl[$basepath][0] = 1;
                                    $popularpaths_dl[$basepath][1][$tokens[1]] = array(0 => $tokens[3], 1 => $tokens[3]);
                                    $popularpaths_dl[$basepath][2] = $tokens[6];
                                }
                                else
                                {   $popularpaths_dl[$basepath][0]++;
                                    if (array_key_exists($tokens[1],$popularpaths_dl[$basepath][1]) == true)
                                    { $popularpaths_dl[$basepath][1][$tokens[1]][1] = $tokens[3]; }
                                    else
                                    { $popularpaths_dl[$basepath][1][$tokens[1]] = array(0 => $tokens[3], 1 => $tokens[3]); }
                                    $popularpaths_dl[$basepath][2] = $popularpaths_dl[$basepath][2] + $tokens[6];
                                }
                                
                                if(isset($popularpaths_dlsize[$basepath]) == false)
                                {   $popularpaths_dlsize[$basepath][0] = $tokens[6];
                                    $popularpaths_dlsize[$basepath][1][$tokens[1]] = array(0 => $tokens[3], 1 => $tokens[3]);
                                    $popularpaths_dlsize[$basepath][2] = 1;
                                }
                                else
                                {   $popularpaths_dlsize[$basepath][0] = $popularpaths_dlsize[$basepath][0] + $tokens[6];
                                    if (array_key_exists($tokens[1],$popularpaths_dlsize[$basepath][1]) == true)
                                    { $popularpaths_dlsize[$basepath][1][$tokens[1]][1] = $tokens[3]; }
                                    else
                                    { $popularpaths_dlsize[$basepath][1][$tokens[1]] = array(0 => $tokens[3], 1 => $tokens[3]); }
                                     $popularpaths_dlsize[$basepath][2] = $popularpaths_dlsize[$basepath][2] + 1;
                                }
                        
                            }
                        }
                    }
                }
            }
        }
        $etime = microtime(true);
        $str_lines               = $linecount;
        $str_time_taken          = round(($etime - $stime),3) . " s";
        $str_size_logfile        = byte_format(filesize($fpath));
        
        echo '<div class="info">';
        // New info
        echo '<table id="gridInfo" class="gridInfo" border="0" cellspacing="0" cellpadding="0"><thead><tr><td width="400">Information</td><td width="100">Value</td></tr></thead><tbody>';
        echo "<tr><td>Total number of lines in LOG file</td><td>$linecount</td></tr>\n";
        //echo "<tr><td>Time taken for analysis</td><td>$str_time_taken</td></tr>\n";
        echo "<tr><td>LOG file size</td><td>$str_size_logfile</td></tr>\n";
        echo "<tr><td>Top Results</td><td>Top$topsize</td></tr>\n";
        echo '</tbody></table>';   
        // 
        echo '</div>';
        
   
        //arsort($popularpaths_dl);
        $arrcount = array_map('col_0', $popularpaths_dl);
        $arrsize = array_map('col_2', $popularpaths_dl);
        array_multisort($arrcount, SORT_DESC, $arrsize, SORT_DESC, $popularpaths_dl);

        $counter = 0;
        if($mode == 4)
            $itemname = "Folders";
        else if($mode == 5)
            $itemname = "Files";
        echo "<h3>Top$topsize - $itemname by Download Requests</h3>";
        echo '<div class="gridcontainer">';
        echo '<table id="grid1" class="grid" border="0" cellspacing="0" cellpadding="0"><thead><tr><td width="40"><div class="mycenter">No.</div></td><td>Filename</td><td width="60" style="text-align:center">Count</td><td width="60" style="text-align:center">Size</td></tr></thead><tbody>';
        foreach($popularpaths_dl as $key => $val)
        {
            $counter++;
            if($counter == 1 || $counter == 2 || $counter == 3)
                $itag = "<div class='medal$counter'></div>";
            else
                $itag = "<div class='rank'>$counter</div>";
                
            $userstr = "";
            if (isset($popularpaths_dl[$key][1]) == true)
               { 
                   foreach ($popularpaths_dl[$key][1] as $userkey => $userval)
                   { 
                       if($mode == 4) { $userstr = $userstr . $userkey . "\n  Start: " . clear_timestamp($userval[0]) . "\n  End: " . clear_timestamp($userval[1]) . "\n"; }
                       else if($mode == 5) { $userstr = $userstr . $userkey . "\n  End: " . clear_timestamp($userval[0]) . "\n"; }
                   } 
               }   
                
          echo "<tr><td>$itag</td><td title='$userstr'><div class='path'>$key</div></td><td style='text-align:right'>$val[0]</td><td white-space: nowrap style='text-align:right'>" . byte_format($val[2],2) . "</td></tr>";
            if($counter >= intval($topsize))
                break;
        }
        echo '</tbody></table>';
        echo '</div>';
        
        //arsort($popularpaths_dlsize);
        $arrcount = array_map('col_0', $popularpaths_dlsize);
        $arrsize = array_map('col_2', $popularpaths_dlsize);
        array_multisort($arrcount, SORT_DESC, $arrsize, SORT_DESC, $popularpaths_dlsize);
        
        $counter = 0;
        echo "<h3>Top$topsize - $itemname by Download Size</h3>";
        echo '<div class="gridcontainer">';
        echo '<table id="grid2" class="grid" border="0" cellspacing="0" cellpadding="0"><thead><tr><td width="40"><div class="mycenter">No.</div></td><td>Filename</td><td width="60" style="text-align:center">Size</td><td width="60" style="text-align:center">Count</td></tr></thead><tbody>';
        foreach($popularpaths_dlsize as $key => $val)
        {
            $counter++;
            if($counter == 1 || $counter == 2 || $counter == 3)
                $itag = "<div class='medal$counter'></div>";
            else
                $itag = "<div class='rank'>$counter</div>";
            
           $userstr = "";
           if (isset($popularpaths_dlsize[$key][1]) == true)
           { 
               foreach ($popularpaths_dlsize[$key][1] as $userkey => $userval)
               { 
                    if($mode == 4) { $userstr = $userstr . $userkey . "\n  Start: " . clear_timestamp($userval[0]) . "\n  End: " . clear_timestamp($userval[1]) . "\n"; }
                    else if($mode == 5) { $userstr = $userstr . $userkey . "\n  End: " . clear_timestamp($userval[0]) . "\n"; }
               } 
           } 
            
            echo "<tr><td>$itag</td><td title='$userstr'><div class='path'>$key</div></td><td white-space: nowrap style='text-align:right'>" . byte_format($val[0],2) . "</td><td style='text-align:right'>$val[2]</td></tr>";
            if($counter >= intval($topsize))
                break;
        }
        echo '</tbody></table>';
        echo '</div>';
        
               
        //arsort($popularpaths_ul);
        $arrcount = array_map('col_0', $popularpaths_ul);
        $arrsize = array_map('col_2', $popularpaths_ul);
        array_multisort($arrcount, SORT_DESC, $arrsize, SORT_DESC, $popularpaths_ul);
        
        $counter = 0;
        echo "<h3>Top$topsize - $itemname by Upload Attempts</h3>";
        echo '<div class="gridcontainer">';
        echo '<table id="grid3" class="grid" border="0" cellspacing="0" cellpadding="0"><thead><tr><td width="40"><div class="mycenter">No.</div></td><td>Filename</td><td width="60" style="text-align:center">Count</td><td width="60" style="text-align:center">Size</td></tr></thead><tbody>';
        foreach($popularpaths_ul as $key => $val)
        {
            $counter++;
            if($counter == 1 || $counter == 2 || $counter == 3)
                $itag = "<div class='medal$counter'></div>";
            else
                $itag = "<div class='rank'>$counter</div>";
           
           $userstr = "";
           if (isset($popularpaths_ul[$key][1]) == true)
           { 
               foreach ($popularpaths_ul[$key][1] as $userkey => $userval)
               { 
                    if($mode == 4) { $userstr = $userstr . $userkey . "\n  Start: " . clear_timestamp($userval[0]) . "\n  End: " . clear_timestamp($userval[1]) . "\n"; }
                    else if($mode == 5) { $userstr = $userstr . $userkey . "\n  End: " . clear_timestamp($userval[0]) . "\n"; }
               } 
           }
  
            echo "<tr><td>$itag</td><td title='$userstr'><div class='path'>$key</Div></td><td style='text-align:right'>$val[0]</td><td white-space: nowrap style='text-align:right'>" . byte_format($val[2],2) . "</td></tr>";

            if($counter >= intval($topsize))
                break;
        }
        echo '</tbody></table>';
        echo '</div>';
        
        //arsort($popularpaths_ulsize);
        $arrcount = array_map('col_0', $popularpaths_ulsize);
        $arrsize = array_map('col_2', $popularpaths_ulsize);
        array_multisort($arrcount, SORT_DESC, $arrsize, SORT_DESC, $popularpaths_ulsize);
        
        $counter = 0;
        echo "<h3>Top$topsize - $itemname by Upload Size</h3>";
        echo '<div class="gridcontainer">';
        echo '<table id="grid4" class="grid" border="0" cellspacing="0" cellpadding="0"><thead><tr><td width="40"><div class="mycenter">No.</div></td><td>Filename</td><td width="60" style="text-align:center">Size</td><td width="60" style="text-align:center">Count</td></tr></thead><tbody>';
        foreach($popularpaths_ulsize as $key => $val)
        {
            $counter++;
            if($counter == 1 || $counter == 2 || $counter == 3)
                $itag = "<div class='medal$counter'></div>";
            else
                $itag = "<div class='rank'>$counter</div>";
            
           $userstr = "";
           if (isset($popularpaths_ulsize[$key][1]) == true)
           { 
               foreach ($popularpaths_ulsize[$key][1] as $userkey => $userval)
               { 
                    if($mode == 4) { $userstr = $userstr . $userkey . "\n  Start: " . clear_timestamp($userval[0]) . "\n  End: " . clear_timestamp($userval[1]) . "\n"; }
                    else if($mode == 5) { $userstr = $userstr . $userkey . "\n  End: " . clear_timestamp($userval[0]) . "\n"; }
               } 
           }
           
           echo "<tr><td>$itag</td><td title='$userstr'><div class='path'>$key</Div></td><td style='text-align:right'>" . byte_format($val[0],2) . "</td><td style='text-align:right'>$val[2]</td></tr>";
           
           if($counter >= intval($topsize))
                break;
        }
        echo '</tbody></table>';
        echo '</div>';
        echo '<div class="page_foot">Page generated in ' . round((microtime(true) - $stime),3) . 's.<div/>';
    }
    
	function genTrafficGraph($filename) // generate Traffic charts
	{
		global $bucketSize;
        if (!(isset($bucketSize) && (is_numeric ($bucketSize))))
            { $bucketSize = 4; }
        
        global $displayTrafficBuckets;
        if (!(isset($displayTrafficBuckets) && ($displayTrafficBuckets === true || $displayTrafficBuckets === false)))
            { $displayTrafficBuckets = false; }
        
        global $displaySpeedBuckets;
        if (!(isset($displayTrafficBuckets) && ($displayTrafficBuckets === true || $displayTrafficBuckets === false)))
            { $displayTrafficBuckets = true; }
        
        global $displayZoomSize;
        if (!(isset($displayZoomSize) && (is_numeric ($displayZoomSize))))
            { $displayZoomSize = 800; }
                                                                                                                                                                                                                                                                                        
        global $date_range ;
        global $traffic_out;
        global $traffic_in;
        
        $fpath = generateLogPath($filename);
		$total_input_size = 0; // total input traffic in bytes
		$total_output_size = 0; // total input traffic in bytes
		$average_input_speed = 0; // average output speed in kb/s
		$average_output_speed = 0; // average output speed in kb/s
		$num_of_logins = 0; // login attempt count
		$num_of_ips    = 0; // login ip count
		$tmp_w_counter = 0;
		$tmp_w_spd_sum = 0;
		$tmp_r_counter = 0;
		$tmp_r_spd_sum = 0;
		$ip_range = array();
		
		$stime = microtime(true);
		$lines = file($fpath);
		$linecount = 0;
        
    	foreach($lines as $line_num => $line)
		{
			$linecount++;
			$line = trim($line);
			$tokens = csv_explode(" ",$line);
            if(count($tokens) >= 6)
            {
			    if($tokens[4] == "w") // input traffic
			    {
				    if(count($tokens) >= 6)
				    {
					    if(is_numeric($tokens[6])) // output size in bytes
					    {
						    $total_input_size += $tokens[6];
						    //echo "Line #<b>{$line_num}</b> : " . htmlspecialchars($line) . ">" . $tokens[7] . "<br>\n";
					    }
					    if(is_numeric($tokens[7])) // check speed field
					    {
						    $tmp_w_spd_sum += $tokens[7];
						    $tmp_w_counter++;
					    }
					    // Build buckets and distribute the download amounts
                        //-----------------------------------------------------------------------------------------
                        $date1            = substr($tokens[3],0,10);
                        $hour1            = substr($tokens[3],11,2);
                        $minute1          = substr($tokens[3],14,2);
                        $second1          = substr($tokens[3],17,2);
 
                        $bucketVal      =  60/$bucketSize;
                        $startbucket    = intval(substr($tokens[3],14,2)/$bucketVal);
                        $myminutes      =   $minute1;
                        while ($myminutes >= $bucketVal) {
                               $myminutes = $myminutes - $bucketVal;
                        }
                        $endbucketpercent =  ($myminutes/$bucketVal) + ($second1/60)/$bucketVal;
                        $sizeperbucket    = (($tokens[7]*1000*60)*$bucketVal);
                        
                        $tmpsize          = $tokens[6];
                        
                        // build buckets 
                        $icount           = 0;
                        $buckets          = array();
                        while  ($tmpsize > 0) {
                            $bucketamount = $tmpsize;
                            if ($sizeperbucket > 0) {
                                if ($icount == 0) {
                                     $firstbucket = $sizeperbucket * $endbucketpercent;
                                     if ($tmpsize >= $firstbucket) { $bucketamount = $firstbucket; }
                                }
                                else {
                                     if ($tmpsize >= $sizeperbucket) { $bucketamount = $sizeperbucket; }
                                 }
                            }
                            
                            $buckets[$icount] = $bucketamount;
                            $tmpsize = $tmpsize - $bucketamount;
                            $icount++;
                        }
                       
                        $traffic_in = addbuckets ("in", $date1, $hour1, $startbucket,  $buckets);
                        unset($buckets);
                        
                        //-----------------------------------------------------------------------------------------//
				    }
			    }
			    else if($tokens[4] == "r") // output traffic
			    {
				    if(count($tokens) == 8)
				    {
					    if(is_numeric($tokens[6])) // output size in bytes
					    {
						    $total_output_size = $total_output_size + $tokens[6];
						    //echo "Line #<b>{$line_num}</b> : " . htmlspecialchars($line) . ">" . $tokens[7] . "<br>\n";
					    }
					    if(is_numeric($tokens[7])) // check speed field
					    {
						    $tmp_r_spd_sum = $tmp_r_spd_sum + $tokens[7];
						    $tmp_r_counter++;
					    }

                        // Build buckets and distribute the download amounts
                        //-----------------------------------------------------------------------------------------
					    $date1            = substr($tokens[3],0,10);
					    $hour1            = substr($tokens[3],11,2);
                        $minute1          = substr($tokens[3],14,2);
                        $second1          = substr($tokens[3],17,2);
 
                        $bucketVal      =  60/$bucketSize;
                        $startbucket    = intval(substr($tokens[3],14,2)/$bucketVal);
                        $myminutes      =   $minute1;
                        while ($myminutes >= $bucketVal) {
                               $myminutes = $myminutes - $bucketVal;
                        }
                        $endbucketpercent =  ($myminutes/$bucketVal) + ($second1/60)/$bucketVal;
                        $sizeperbucket    = (($tokens[7]*1000*60)*$bucketVal);
                        
                        $tmpsize          = $tokens[6];
                        
                        // build buckets 
                        $icount           = 0;
                        $buckets          = array();
                        while  ($tmpsize > 0) {
                            $bucketamount = $tmpsize;
                            if ($sizeperbucket > 0) {
                                if ($icount == 0) {
                                     $firstbucket = $sizeperbucket * $endbucketpercent;
                                     if ($tmpsize >= $firstbucket) { $bucketamount = $firstbucket; }
                                }
                                else {
                                     if ($tmpsize >= $sizeperbucket) { $bucketamount = $sizeperbucket; }
                                 }
                            }
                            
                            $buckets[$icount] = $bucketamount;
                            $tmpsize = $tmpsize - $bucketamount;
                            $icount++;
                        }
                       
                        $traffic_out = addbuckets ("out", $date1, $hour1, $startbucket,  $buckets);
                        unset($buckets);
                       //-----------------------------------------------------------------------------------------//
				    }
			    }
			    else if($tokens[4] == "l") // login attempt
			    {
				    $num_of_logins++;
			    }
			}
            $ips = $tokens[0];
			if(isset($ip_range[$ips]) == false)
				$ip_range[$ips] = 1;
			else
				$ip_range[$ips] = $ip_range[$ips] + 1;
		}
        
		// Now we process
        //-----------------------------------------------------------------------------------------
        $etime = microtime(true);
		$str_lines               = $linecount;
		$str_time_taken          = round(($etime - $stime),3) . " s";
		$str_size_logfile        =  byte_format(filesize($fpath),2);
		$str_total_upload_size   =  byte_format($total_input_size,2);
        if ($tmp_w_counter > 0)
		    $str_avg_upload_spd      = sprintf("%.2f",$tmp_w_spd_sum/$tmp_w_counter) . " Kb/s";
        else 
            $str_avg_upload_spd      = sprintf("%.2f",0) . " Kb/s";
        $str_total_download_size =  byte_format($total_output_size,2);
        if ($tmp_r_counter > 0)
            $str_avg_download_spd    = sprintf("%.2f",$tmp_r_spd_sum/$tmp_r_counter) . " Kb/s";
		else
            $str_avg_download_spd      = sprintf("%.2f",0) . " Kb/s";
        $str_num_logins          = $num_of_logins;
		$str_num_ip_origins      = count($ip_range);
		$str_most_active_ip      = "";
		arsort($ip_range);
		foreach($ip_range as $key => $val)
		{
			$str_most_active_ip  =  $key;
			break;
		}
		
        echo "<div class='info'>";
        // New info
        echo '<table id="gridInfo" class="gridInfo" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=400>Information</td><td width=100>Value</td></tr></thead><tbody>';
        echo "<tr><td>Total number of lines in LOG file</td><td>$linecount</td></tr>\n";
        //echo "<tr><td>Time taken for analysis</td><td>$str_time_taken</td></tr>\n";
        echo "<tr><td>LOG file size</td><td>$str_size_logfile</td></tr>\n";
        echo "<tr><td>Total upload size</td><td>$str_total_upload_size </td></tr>\n";
        echo "<tr><td>Average upload speed</td><td>$str_avg_upload_spd</td></tr>\n";
        echo "<tr><td>Total download size</td><td>$str_total_download_size </td></tr>\n";
        echo "<tr><td>Average download speed</td><td>$str_avg_download_spd</td></tr>\n";
        echo "<tr><td>Number of login attempts</td><td>$str_num_logins</td></tr>\n";
        echo "<tr><td>Total IP addresses</td><td>$str_num_ip_origins</td></tr>\n";
        echo "<tr><td>Most active IP addresse</td><td>$str_most_active_ip</td></tr>\n";
        echo '</tbody></table>'; 
        echo "</div>";  
        //
       
        asort($date_range); // old date first
		if(isset($_REQUEST['dateselbox_s']) == true && $_REQUEST['dateselbox_s'] != "")
			$start_date = $_REQUEST['dateselbox_s'];
		if(isset($_REQUEST['dateselbox_e']) == true && $_REQUEST['dateselbox_e'] != "")
			$end_date = $_REQUEST['dateselbox_e'];
		foreach($date_range as $key => $val)
		{
			if(($val >= $start_date && $val <= $end_date) || (isset($start_date) == false && isset($end_date) == false))
			{
				$param_out = "";
				$param_in = "";
				
               echo "<div class='info'>";
                echo "<table>\n";
                echo '<COL id="col1"><COL id="col2">';
                echo '<TR id="row1">';
                echo "    <TD> <h4>[$val]" . "</h4>\n";
                //echo "    <TD> <h2>Average speed on $val" . "</h2>\n";
                //echo "<h2>Net traffic on $val" . "</h2>\n";
                
                $dayTrafficOut = 0;
				for($i=0;$i<24;$i++)
				{
					$khour = sprintf("%02d",$i);
                    $hourData = array();
                    $data_out  = "";
					
                    if(isset($traffic_out[$val][$khour]))
					{
						if ($displayTrafficBuckets) {
                            $hourData = $traffic_out[$val][$khour]['data'];
                            $data_out = $hourData[0]['size']; 
                            for ($j=1;$j<$bucketSize;$j++) {
                                $data_out = $data_out . ";" . $traffic_out[$val][$khour]['data'][$j]['size'];
                            }
                            $param_out = $param_out . $khour . ":" .  $data_out . ",";
                        }
                        else {
                            $param_out = $param_out . $khour . ":" . $traffic_out[$val][$khour]['totalSize'] . ",";
                            
					    }
                        $dayTrafficOut += $traffic_out[$val][$khour]['totalSize'];
                    }
				}
				//echo "<p>UL:</p>\n";
				
                $dayTrafficIn = 0;
                for($i=0;$i<24;$i++)
				                {
                    $khour = sprintf("%02d",$i);
                    $hourData = array();
                    $data_in  = "";
                    
                    if(isset($traffic_in[$val][$khour]))
                    {
                        if ($displayTrafficBuckets) {
                            $hourData = $traffic_in[$val][$khour]['data'];
                            $data_in = $hourData[0]['size']; 
                            for ($j=1;$j<$bucketSize;$j++) {
                                $data_in = $data_in . ";" . $traffic_in[$val][$khour]['data'][$j]['size'];
                            }
                            $param_in = $param_in . $khour . ":" .  $data_in . ",";
                        }
                        else {
                            $param_in = $param_in . $khour . ":" . $traffic_in[$val][$khour]['totalSize'] . ",";
                        }
                        $dayTrafficIn += $traffic_in[$val][$khour]['totalSize'];
                    }
                }
                echo '<TR id="row2">';
                $fullurl = "operate.php?op=trafficchart&param1=" . $param_out . "&param2=" . $param_in  . "&param3=" . $key;
				$title = "#Traffic#\n" . "UP: " . byte_format($dayTrafficIn,1) . "\nDN: " . byte_format($dayTrafficOut,1);
                echo "    <TD> <center><a title=\"" . $title . "\" href=\"".$fullurl."&size=".$displayZoomSize."&dummy=.png\"><img width=380 height=175 src=\"".$fullurl."&size=380&dummy=.png\" /></a></center></TD>";
                //echo "<center><img width=640 height=220 src='" . "operate.php?op=trafficchart&param1=" . $param_out . "&param2=" . $param_in  . "&param3=" . $key . "'></center>";
				//echo "<h2>The average speed of U/L and D/L on $val" . "</h2>\n";
				$param_out = "";
				$param_in = "";
               
				$dayAvgOut = 0;
                $dayAvgCalcOut = 0;
                $daySumOut = 0;
                for($i=0;$i<24;$i++)
				{
					$khour = sprintf("%02d",$i);
                    $hourData = array();
                    $dataout  = "";
                    
					if(isset($traffic_out[$val][$khour]))
					{   
                        if ($displaySpeedBuckets) {
                            $hourData = $traffic_out[$val][$khour]['data'];
                            $data_out = $hourData[0]['speed']; 
                            for ($j=1;$j<$bucketSize;$j++) {
                                $data_out = $data_out . ";" . $traffic_out[$val][$khour]['data'][$j]['speed'];
                            }
                            $param_out = $param_out . $khour . ":" .  $data_out . ",";
                        }
                        else {
                            $param_out = $param_out . $khour . ":" . $traffic_out[$val][$khour]['avgSpeed'] . ",";
                        }
                        $dayAvgCalcOut += $traffic_out[$val][$khour]['avgSpeed']*$traffic_out[$val][$khour]['totalSize'];
                        $daySumOut += $traffic_out[$val][$khour]['totalSize']; 
					}
				}
                if ($daySumOut > 0) { $dayAvgOut = $dayAvgCalcOut/$daySumOut; }

                $dayAvgIn =0;
                $dayAvgCalcIn = 0;
                $daySumIn = 0;
				for($i=0;$i<24;$i++)
				{
					$khour = sprintf("%02d",$i);
                    $hourData = array();
                    $datain  = "";
                    
					if(isset($traffic_in[$val][$khour]))
					{
						if ($displaySpeedBuckets) {
                            $hourData = $traffic_in[$val][$khour]['data'];
                            $data_in = $hourData[0]['speed']; 
                            for ($j=1;$j<$bucketSize;$j++) {
                                $data_in = $data_in . ";" . $traffic_in[$val][$khour]['data'][$j]['speed'];
                            }
                            $param_in = $param_in .$khour . ":" .  $data_in . ","; 
                        }
                        else {
                            $param_in = $param_in . $khour . ":" . $traffic_in[$val][$khour]['avgSpeed'] . ",";
                        } 
                        $dayAvgCalcIn += $traffic_in[$val][$khour]['avgSpeed']*$traffic_in[$val][$khour]['totalSize'];
                        $daySumIn += $traffic_in[$val][$khour]['totalSize'];                                                                           
                    }
                    if ($daySumIn > 0) { $dayAvgIn = $dayAvgCalcIn/$daySumIn; }
				}
                $fullurl = "operate.php?op=spdchart&param1=" . $param_out . "&param2=" . $param_in  . "&param3=" . $key; 
				$title = "#Speed#\n" . "UP: " . kbs_format($dayAvgIn,1) . "\nDN: " . kbs_format($dayAvgOut,1);
                echo "    <TD> <center><a title=\"" .$title . "\" href=\"".$fullurl."&size=".$displayZoomSize."&dummyType=.png\"><img width=380 height=175 src=\"".$fullurl."&size=380&dummyType=.png\" onload=\"javascript:setupZoom();\" /></a></center></TD>";
                echo "</tr>\n";
                echo "</Table>\n";
                echo "</div>";
            }
		}
		echo "</div>";
        echo '<div class="page_foot">Page generated in ' . round((microtime(true) - $stime),3) . 's.<div/>';
	}

	function createChart($op,$arro,$arri,$date,$size) // generate individual Graph
	{   
        header("Content-type: image/png");
		$stime = microtime(true);
        $arr_out = array();
        $arr_in = array();

        
        //sleep(4);
        
        
        global $displayGradientBars;
        if (!(isset($displayGradientBars) && ($displayGradientBars === true || $displayGradientBars === false)))
            { $displayGradientBars = false; }
        
        global $bucketSize;
        if (!(isset($bucketSize) && (is_numeric ($bucketSize))))
            { $bucketSize = 4; }
            
        $maxYval = 0;
        $maxbarYval =0;
		$xAxisTitle = "Hrs";
		$sysroot = getenv("SystemRoot");
		$font = $sysroot . "\\fonts\\" . 'segoeui.ttf';
		if(file_exists($font) == false)
			$font = $sysroot . "\\fonts\\" . 'arial.ttf';
		
        if($op == "spdchart")
		{
			$yAxisTitle1 = "Speed";
			$yAxisTitle2 = "";
			$topTitle = "Speed - " . $date;
		}
		else if($op == "trafficchart" || isset($op) == false)
		{
			$yAxisTitle1 = "Traffic";
			$yAxisTitle2 = "";
			$topTitle = "Traffic - " . $date;
		}
        $legendUp = "Upload";
        $legendDn = "Download";
        
        //default size
        if((isset($size) == false) || ($size == "") || ($size < 480)) {  $size = 480; }
      
        //Grid config
		$imgWidth = intval($size);
        $imgHeight = $imgWidth * 0.458333;
        $imgRatio = ($imgWidth/480);
        if ($imgRatio < 1) {$imgRatio = 0 - $imgRatio*2; }
        $marginTop = 15;
        $marginRight = 15;
        $titleSize= 7 + intval($imgRatio);
        $topTitleSize= 9 + intval($imgRatio);
        $legendbox = calculateTextBox('123456789',$font,$titleSize,0);
        $line_y_base = $imgHeight-2*$legendbox['height'];
        // calculate and set baseX
        if($op == "spdchart") { $txt = "1000.0 Mb/s"; }
        else if($op == "trafficchart") { $txt = "1000.0 Mb"; }
        $txtTitlebox = calculateTextBox($txt,$font,$titleSize,0);
        $line_x_base = $txtTitlebox["width"]+10*$imgRatio;
        //set the grid size and bar width
        $txtTitlebox = calculateTextBox($xAxisTitle,$font,$titleSize,0);
        $grid = (($imgWidth-$line_x_base-$marginRight-$txtTitlebox['width'])/24.5);
        $barWidth=intval($grid/2)-3;
                        
        $im = @imagecreatetruecolor($imgWidth,$imgHeight) or die("Cannot Initialize new GD image stream");

        //colors
        $background_color = imagecolorallocate($im,220,229,236);
        imagefill($im,0,0,$background_color);

		$text_color = imagecolorallocate($im,77,108,140);
		$title_color = imagecolorallocate($im,0,0,0);
		$dash_color = imagecolorallocate($im,190,200,200);

		$border_t = imagecolorallocate($im,200,200,200);
		$border_d = imagecolorallocate($im,170,170,170);
		$border_l = imagecolorallocate($im,200,200,200);
		$border_r = imagecolorallocate($im,170,170,170);

        $tr = IMG_COLOR_TRANSPARENT;
        $style = array($dash_color,$tr,$dash_color,$tr,$dash_color,$tr,$dash_color,$tr,$dash_color,$tr);

		$baseline_color = imagecolorallocate($im,0,0,5);
		$line_color1 = imagecolorallocate($im,0,100,0);
        $line_color1d = imagecolorallocate($im,0,60,0);
		$line_color2 = imagecolorallocate($im,160,0,0);
        $line_color2d = imagecolorallocate($im,100,0,0);
        
         //title
        $topTitlebox = calculateTextBox($topTitle,$font,$topTitleSize,0); 
        imagettftext($im,$topTitleSize,0,($imgWidth/2)-($topTitlebox['width']/2),$marginTop+($topTitlebox['height']*$imgRatio/2),$text_color,$font,$topTitle);
		
        //borders
        imageline($im,0,0,$imgWidth-1,0,$border_t);
		imageline($im,0,$imgHeight-1,$imgWidth-1,$imgHeight-1,$border_d);
		imageline($im,0,0,0,$imgHeight-1,$border_l);
		imageline($im,$imgWidth-1,0,$imgWidth-1,$imgHeight-1,$border_r);
        
        // Legend
        $legendbox = calculateTextBox($legendDn,$font,$titleSize,0);
        $xpos = $imgWidth-$marginRight-$legendbox['width'];
        $ypos = $marginTop+$legendbox['height'];
        imagettftext($im,$titleSize,0,$xpos,$ypos,$line_color2d,$font,$legendUp);
        imagettftext($im,$titleSize,0,$xpos,$ypos + 10,$line_color1d,$font,$legendDn);
        
        //explode input data
        for ($cnt=0;$cnt<2;$cnt++) {
            $arr_tmp = array();
            if ($cnt == 0) { $arrchk = $arro; }
            else if ($cnt == 1) { $arrchk = $arri; }
            else { die("Cannot process data"); }
                
		    $arr0 = explode(",",$arrchk);
		    foreach($arr0 as $key => $val) {
			    $arr1 = explode(":",$val);
			    if(count($arr1) == 2) {
				    if($arr1[0] >= 0 && $arr1[0] <= 23) {
                        $arr2 = explode(";",$arr1[1]);
                        array_walk($arr2, create_function('&$val', '$val = floatval($val);'));
                        $sum = array_sum($arr2);
                        $arr_tmp[$arr1[0]] = $arr2;

                        rsort($arr2);
                        if($arr2[0] > $maxYval) { $maxYval = $arr2[0]; }
                        if($sum > $maxbarYval) { $maxbarYval = $sum; }
      			    }
			    }
		    }
            
            if ($cnt == 0) { $arr_out = $arr_tmp; }
            else if ($cnt == 1) { $arr_in = $arr_tmp; } 
		}

        //set $maxYval to default if 0
        if ($maxYval <= 0) { $maxYval = 100; }
        if ($op == "trafficchart") { $maxYval = $maxbarYval; }
        if ($maxbarYval <= 0) {$maxbarYval = 100; }
        // $maxYval = 100;
 
        // Grid
        imagesetstyle($im, $style);
        
        // START Grid --------------------------------------------------------------
        //Set X axis and title
        $txtTitlebox = calculateTextBox($xAxisTitle,$font,$titleSize,0);
        $posY =  $line_y_base+($imgHeight-$line_y_base)/2+$txtTitlebox['height']/2;
        imagettftext($im,$titleSize,0,$imgWidth-$marginRight-$txtTitlebox['width'],$posY,$title_color,$font,$xAxisTitle);
        
        $startDashY = $line_y_base-$imgRatio;
        $endDashY   = $line_y_base+$imgRatio;
        $gridLength = $line_y_base-($grid*10.5);
        for($i=1;$i<=24;$i++) {
            $xpos = $line_x_base+($i*$grid);
            $txtbox = calculateTextBox($i,$font,$titleSize,0);
            imagettftext($im,$titleSize,0,$xpos-($txtbox['width']/2),$posY,$text_color,$font,$i);
            imageline($im,$xpos,$line_y_base,$xpos,$gridLength,IMG_COLOR_STYLED);
            imageline($im,$xpos,$startDashY,$xpos,$endDashY,$text_color);
		}
        
        // Set Y axis and title
        $ySlice = $maxYval/10;
        for($i=0;$i<=10;$i++) {
            $yVal =   $ySlice*$i;
			$txt = sprintf("%d",$ySlice*$i);
			if($op == "spdchart") { $txt = kbs_format($txt,1); }
			else if($op == "trafficchart") { $txt = byte_format($yVal,1); }
				
            if($i > 0) {
                $txtbox = calculateTextBox($txt,$font,$titleSize,0);
                $ypos = $line_y_base-($grid*$i);
				imagettftext($im,$titleSize,0,$line_x_base - $txtbox['width']- 5*$imgRatio,$ypos+($txtbox['height']/2),$text_color,$font,$txt);
                imageline($im,$line_x_base,$ypos,$line_x_base+($grid*24.5),$ypos,IMG_COLOR_STYLED);
                imageline($im,$line_x_base-$imgRatio,$ypos,$line_x_base+$imgRatio,$ypos,$text_color);
			}
		}
        
        // set the main title
        $txtbox = calculateTextBox($yAxisTitle1,$font,$titleSize,0);
        imagettftext($im,$titleSize,0,$line_x_base - $txtbox['width']- 5*$imgRatio,$marginTop+$txtbox['height'],$title_color,$font,$yAxisTitle1);
        // END Grid --------------------------------------------------------------
        
		for ($cnt=0;$cnt<2;$cnt++) {
            if ($cnt == 0) {
                $arrprocess = $arr_out;
                $color = $line_color1;
                $colord = $line_color1d;
            }
            else if ($cnt == 1) {
                $arrprocess = $arr_in;
                $color = $line_color2;
                $colord = $line_color2d;
            }
            else { die("Cannot process data"); } 
                
            // starting position         
            $lastx = $line_x_base;
            $lasty = $line_y_base;
           
            //Process output data
            imageantialias($im,true);
            for($i=0;$i<24;$i++) {
                $i = sprintf("%02d",$i);
                if (array_key_exists ($i,$arrprocess) == false) {
                    if ($lasty == $line_y_base) { $arrprocess[$i] = array(0); }
                    else {
                        for ($k=0;$k<$bucketSize;$k++) {
                            $arrprocess[$i][$k] = 0;
                        }
                    }
                }
                if ($op == "spdchart") {
                    $baseUnit = $grid/count($arrprocess[$i]);
                    $eliSize  = $grid/7;
                
                    for($j=0;$j<count($arrprocess[$i]);$j++) {
                        $moveY = $grid*10 * ($arrprocess[$i][$j]/$maxYval);
                        $moveX = ($i*$grid)+($j*$baseUnit)+$baseUnit;

                        //do not draw if first line
                        $newX = $line_x_base+$moveX;
                        $newY = $line_y_base-$moveY;
                        if ((($lastx == $line_x_base) && ($lasty == $line_y_base)) == false) {
                            imageline($im,$lastx,$lasty,$newX, $newY,$colord);
                        }
                        imagefilledellipse($im ,$newX,$newY,$eliSize,$eliSize, $color);
                        $lastx = $newX;
                        $lasty = $newY;
                    }
                }
                else if($op == "trafficchart") {
                    $moveX = ($i*$grid)+$grid;
                                        
                    if ($cnt == 0) { // up bar
                        $barStart = $lastx+($grid-$barWidth-1);
                        $barEnd   = $line_x_base+($i*$grid)+$grid;
                    
                        for($j=0;$j<count($arrprocess[$i]);$j++) {
                            
                            $moveY = $grid*10 * ($arrprocess[$i][$j]/$maxbarYval);   
                            
                            if ($displayGradientBars == true) { drawbar($im,$barStart,$lasty,$barEnd,$lasty-$moveY,$line_color1,$line_color1d); }
                            else { imagefilledrectangle($im ,$barStart,$lasty,$barEnd,$lasty-$moveY,$line_color1); }
                            
                            $lastx = $lastx;
                            $lasty = $lasty-$moveY;
                        }
                   }
                    
                    else if ($cnt == 1) { //dn bar
                       $barStart = $lastx+$grid+1;
                       $barEnd   = $line_x_base+($i*$grid)+$grid+$barWidth+2;
                    
                       for($j=0;$j<count($arrprocess[$i]);$j++) {
                            $moveY = $grid*10 * ($arrprocess[$i][$j]/$maxYval);   
                            
                            if ($displayGradientBars == true) { drawbar($im ,$barStart,$lasty,$barEnd,$lasty-$moveY,$line_color2,$line_color2d); }
                            else { imagefilledrectangle($im ,$barStart,$lasty,$barEnd,$lasty-$moveY,$line_color2); }
        
                            $lasty = $lasty-$moveY;
                        }
                    }   
                    $lastx = $line_x_base+$moveX;
                    $lasty = $line_y_base;
                }
            }
            imageantialias($im,false);    
        }
		
        imageantialias($im,true); 
        //Axis y
        $xret = $imgWidth-$marginRight;
        imageline($im,$line_x_base,$line_y_base,$xret,$line_y_base,$baseline_color); 
        imagefilledpolygon($im, array($xret-5,$line_y_base-2,$xret-5,$line_y_base+2,$xret,$line_y_base), 3, $baseline_color);
       
       //Axis x
        imageline($im,$line_x_base,$marginTop,$line_x_base,$line_y_base,$baseline_color);
        imagefilledpolygon($im, array($line_x_base-2,$marginTop+5,$line_x_base+2,$marginTop+5,$line_x_base,$marginTop), 3, $baseline_color); 
        imageantialias($im,false); 
        
        $etime = microtime(true);
        //imagettftext($im,$titleSize,0,10,10,$text_color,$font,$etime-$stime);
        
        //Output        
        imagepng($im);
        imagedestroy($im);
	}

    // Functions --------------------------------------------
	function initTrafficDate ($arr,$date,$hour) {  
        global $bucketSize;
        if(isset($arr[$date][$hour]) == false) {
            $arr[$date][$hour]['avgSpeed'] = 0;
            $arr[$date][$hour]['totalSize'] = 0;

            for ($i=0;$i<=$bucketSize-1;$i++) {
                 $arr[$date][$hour]['data'][$i]= array('size' => 0, 'speed' => 0);
            }
        }
        return $arr;
    }
    function addbuckets ($dir, $date, $hour, $startbucket, $arrbuckets) {
        global $bucketSize;
        global $date_range;
        global $traffic_out;
        global $traffic_in;
        
        if ($dir == "in") {$arr = $traffic_in; }
        else if ($dir == "out") {$arr = $traffic_out; }
        else { die ("error"); }
        
        $arr = initTrafficDate($arr,$date,$hour);
           
        for ($i=0;$i<count($arrbuckets);$i++) {
            $bucketindex = $startbucket-$i;
            if ($bucketindex<0){
                $tmp =  intval(((abs($bucketindex)-1)/6)) + 1;
                $dt = strtotime($date . " " . $hour . ":00:00") - ( ($tmp)*3600);
                $prevhour = date("H",$dt);
                $prevdate = date("Y/m/d",$dt);
                  
               $arr = initTrafficDate ($arr,$prevdate,$prevhour);
               $tmpbucketid = ($bucketSize-1) + (($bucketindex+1) % $bucketSize);
               $arr[$prevdate][$prevhour]['totalSize'] +=  $arrbuckets[$i];
               $arr[$prevdate][$prevhour]['avgSpeed'] =  round(($arr[$prevdate][$prevhour]['totalSize'] / 1000) / 3600,1);
               $arr[$prevdate][$prevhour]['data'][$tmpbucketid]['size'] +=  $arrbuckets[$i]; 
               $arr[$prevdate][$prevhour]['data'][$tmpbucketid]['speed'] =  round(($arr[$prevdate][$prevhour]['data'][$tmpbucketid]['size'] / 1000) / (60*(60/$bucketSize)),1);

               if(isset($date_range[$prevdate]) == false) // there is traffic in this day
                   $date_range[$prevdate] = $prevdate;
            }
            else {
                $arr[$date][$hour]['totalSize'] +=  $arrbuckets[$i];
                $arr[$date][$hour]['avgSpeed']  =  round(($arr[$date][$hour]['totalSize'] / 1000) / 3600, 2);
                $arr[$date][$hour]['data'][$startbucket-$i]['size'] +=  $arrbuckets[$i];
                $arr[$date][$hour]['data'][$startbucket-$i]['speed'] =  round(($arr[$date][$hour]['data'][$startbucket-$i]['size'] / 1000) / (60*(60/$bucketSize)),1);
                
                if(isset($date_range[$date]) == false) // there is traffic in this day
                     $date_range[$date] = $date;
            }
        }
        
     return $arr;   
    }
    function drawbar ($im,$startX=0, $startY=0, $endX=0, $endY=0, $startColor='000000', $endColor='FFFFFF') {
        
        $startR = ($startColor >> 16) & 0xFF;
        $startG = ($startColor >> 8) & 0xFF;
        $startB = $startColor & 0xFF;
        $endR   = ($endColor >> 16) & 0xFF;
        $endG   = ($endColor >> 8) & 0xFF;
        $endB   = $endColor & 0xFF;
        
        $height =  $startY - $endY;
        $width  =  $startX - $endY; 
        
        for($y=0;$y<$height;$y++) {
            if ($startR == $endR) { $newR = $startR; }
            $diffR = $startR - $endR;
            $newR = $startR - intval(($diffR / $height) * $y); 
            
            if ($startG == $endG) { $newG = $startG; }
            $diffG = $startG - $endG;
            $newG = $startG - intval(($diffG / $height) * $y);         
            
            if ($startB == $endB) { $newB = $startB; }
            $diffB = $startB - $endB;
            $newB = $startB - intval(($diffB / $height) * $y);
            
            $row_color = imagecolorresolve($im, $newR, $newG, $newB);
            
            imagefilledrectangle($im ,$startX,$startY-$y,$endX,$startY-$y-1,$row_color);
          }    
    }
    function calculateTextBox($text,$fontFile,$fontSize,$fontAngle) { 
        /************ 
        simple function that calculates the *exact* bounding box (single pixel precision).
         The function returns an associative array with these keys: 
        left, top:  coordinates you will pass to imagettftext 
        width, height: dimension of the image you have to create 
        *************/ 
        $rect = imagettfbbox($fontSize,$fontAngle,$fontFile,$text); 
        $minX = min(array($rect[0],$rect[2],$rect[4],$rect[6])); 
        $maxX = max(array($rect[0],$rect[2],$rect[4],$rect[6])); 
        $minY = min(array($rect[1],$rect[3],$rect[5],$rect[7])); 
        $maxY = max(array($rect[1],$rect[3],$rect[5],$rect[7])); 
        
        return array( 
         "left"   => abs($minX) - 1, 
         "top"    => abs($minY) - 1, 
         "width"  => $maxX - $minX, 
         "height" => $maxY - $minY, 
         "box"    => $rect 
        ); 
    }
    function generateLogPath($filename) { // generate log path
    
        global $rdnpath;
        if(isFilenameSecure($filename) == false)
            die("Invalid filename");
        $ext = getFileType($filename);
        if($ext != "log")
            die("Not a Log file");
        $fpath = $rdnpath . "\\log\\" . $filename;
        if(file_exists($fpath) == true)
            return $fpath;
        else
            die("invalid log file path");
    }
    function getCommand($cmdstring) { // map FTP commands
    
        $command = "";
        
        if($cmdstring == "l")     { $command = "Login"; }
        elseif($cmdstring == "m") { $command = "Create"; }
        elseif($cmdstring == "w") { $command = "Upload"; }
        elseif($cmdstring == "r") { $command = "Download"; }
        elseif($cmdstring == "s") { $command = "SiteCmd"; }
        elseif($cmdstring == "d") { $command = "Delete"; }
        elseif($cmdstring == "e") { $command = "Error"; }
        elseif(substr($cmdstring,0,6) == "ask://")   { $command = "Ask"; }
        elseif(substr($cmdstring,0,7) == "exec://")  { $command = "Exec"; }
        elseif(substr($cmdstring,0,7) == "file://")  { $command = "File"; }
        elseif(substr($cmdstring,0,7) == "http://")  { $command = "Http"; }
        elseif(substr($cmdstring,0,6) == "log://")   { $command = "Log"; }
        elseif(substr($cmdstring,0,6) == "queue://") { $command = "Queue"; }
    
        return $command;
    }
    // END Functions -----------------------------------------

    if(isset($_SESSION['logon_user']) == false)
		die("Not logged in");
	if(isset($_REQUEST['op']) == true)
		$op = $_REQUEST['op'];
	else
		$op = "";
	if(isset($_REQUEST['param1']) == true)
		$p1 = rawurldecode($_REQUEST['param1']);
	else
		$p1 = "";
	if(isset($_REQUEST['param2']) == true)
		$p2 = rawurldecode($_REQUEST['param2']);
	else
		$p2 = "";
	if(isset($_REQUEST['param3']) == true)
		$p3 = rawurldecode($_REQUEST['param3']);
	else
		$p3 = "";
    if(isset($_REQUEST['size']) == true)
        $size = rawurldecode($_REQUEST['size']);
    else
        $size = "";

	if($op == "trafficgraph")
	{
		genTrafficGraph($p1);
	}
	else if($op == "topstatistics")
	{
		genTopstatistics($p1);
	}
	else if($op == "daterange")
	{
		queryDateRange($p1);
	}
	else if($op == "hitometer")
	{
		genHitoMeter($p1,$p2);
	}
	else if($op == "showoperation")
	{
		genLogList($p1,$p2);
	}
	else if($op == "usage")
	{
		genUsage($p1,$p2);
	}
    else if($op == "rawlog")
    {
        include ("filter.php");
    }
    else if(($op == "rawlogquery") || ($op == "showfoldersdl") || ($op == "showfoldersul"))
    {
        if ($op == "showfoldersdl") { $actions = "download"; }
        if ($op == "showfoldersul") { $actions = "upload"; }
        genFilteredLogList($p1);
    }
	else if($op == "spdchart" || $op == "trafficchart")
	{
		createChart($op,$p1,$p2,$p3,$size);
	}
?>